from fenics import *
from mshr import *
dom = Rectangle(Point(0,0), Point(1.2, .4)) - Circle(Point(.3, .2), 0.15)
mesh = generate_mesh(dom, 8)
mesh_fine = refine(mesh)
markers = CellFunction('bool', mesh)
markers.set_all(False)
for c in cells(mesh):
    if (c.midpoint()[0] < .6): markers[c] = True
mesh_partial_fine = refine(mesh, markers)
plot(mesh)
plot(mesh_fine)
plot(mesh_partial_fine)
interactive()
